/* ***************
// overlay.js
//
// Author: Zigler Zhang (fireinice@gmail.com)
// 0.2:To auto Reload the Page with a specified proxy when load page faild
// Contributors:
//   Bruce.G.Khereid
//   Ziya
//   ...
****************** */

window.addEventListener("load", function(e) { fireProxy.init();}, false);

function showNotification( aPage){
	var tabbrowser = document.getElementById("content");
	var gBrowser = getBrowser();
	var panel = tabbrowser.getNotificationBox( gBrowser.getBrowserForDocument( aPage));
	var localStrs = document.getElementById("errPageStrs");
	var locDoc = aPage.location;
	
  	var buttons = [
  	{
	    label: localStrs.getString( "butTag1"),
	    accessKey: "S",
	    popup: null,
	    callback: function(){ 
	    	var	locDoc = content.document.location;
	    	PACFile.addSiteToFile( locDoc);
	    }
  	},
  	{
	    label: localStrs.getString( "butTag2"),
	    accessKey: "A",
	    popup: null,
	    callback: function(){ 
	    	var	locDoc = content.document.location;
	    	PACFile.addDomainToFile( locDoc);
	    }
  	}
//  	{
//    label: localStrs.getString( "butTag3"),
//    accessKey: "O",
//    popup: "notifyPopup",
//    callback: null,
//  	}
  ];
  
  panel.appendNotification(localStrs.getString( "warningMessage")/*text*/, 
  	  						"with-proxy",/*value*/"chrome://browser/skin/Info.png",/*icon*/
  							panel.PRIORITY_WARNING_LOW/*priority*/, buttons);
}

var fireProxy = {
	init: function()
	{
//    	Check if FireProxy Enabled
    	const fireProxyEnabled = "extensions.fireproxy.enabled";
  		if( !commTools.PREFS.getBoolPref( fireProxyEnabled))
  		{
  			return;
  		}
  		var appcontent = document.getElementById("content");
    	if(appcontent){
    		appcontent.addEventListener( "DOMContentLoaded", this.onPageLoad, true);
  		}
   	},
    
    onPageLoad: function( anEvent)
    {

//		Check if pageload concerns a document (and not a favicon or something similar)
		var page = anEvent.originalTarget;
		var locDoc = page.location;
		var docURI = commTools.URIFIXUP.createFixupURI( locDoc.toString(), 0);
		
		if(page.nodeName != "#document"){ 
			return;
		}else if( CusProxy.removeProxy( docURI)){
			showNotification( page);
			return;
		}else{
			var urlString = page.URL;
			if( urlString.length < 8 || urlString.substr(6,8) != "neterror"){
//			Judge if it's an error
				return;
			}                                                     
			if( CusProxy.applyProxy( docURI)){
				commTools.debug( CusProxy.uriList.length + "yes");
		    	locDoc.reload(false); 	
	    	}
	    	commTools.debug("edn");
	    }
    }
}
